From cf00c8bb2ab08702dce6f0e521f9fe3a1b5dc78d Mon Sep 17 00:00:00 2001
From: Takashi Kato <tohosaku@users.osdn.me>
Date: Tue, 16 Sep 2025 12:28:31 +0000
Subject: [PATCH 1/2] Add japanese common_mark help

---
 .../ja/wiki_syntax_common_mark.html.erb       |  96 ++++
 .../wiki_syntax_detailed_common_mark.html.erb | 428 ++++++++++++++++++
 2 files changed, 524 insertions(+)
 create mode 100644 app/views/help/wiki_syntax/common_mark/ja/wiki_syntax_common_mark.html.erb
 create mode 100644 app/views/help/wiki_syntax/common_mark/ja/wiki_syntax_detailed_common_mark.html.erb

diff --git a/app/views/help/wiki_syntax/common_mark/ja/wiki_syntax_common_mark.html.erb b/app/views/help/wiki_syntax/common_mark/ja/wiki_syntax_common_mark.html.erb
new file mode 100644
index 0000000000..15268ac42e
--- /dev/null
+++ b/app/views/help/wiki_syntax/common_mark/ja/wiki_syntax_common_mark.html.erb
@@ -0,0 +1,96 @@
+<!DOCTYPE html>
+<html>
+<head>
+<meta charset="UTF-8">
+<title>Wiki formatting</title>
+<%= stylesheet_link_tag "wiki_syntax.css" %>
+</head>
+<body>
+
+<h1>Wiki記法 クイックリファレンス (CommonMark Markdown (GitHub Flavored))</h1>
+
+<table style="width:100%">
+<tr><th colspan="3">Font Styles <span class="more_info">(<a href="wiki_syntax_detailed_markdown.html#5" target="_blank">詳細</a>)</span></th></tr>
+<tr><th><%= image_tag("jstoolbar/bold.svg", { alt: "太字" }) %></th><td style="width:50%;">**太字**</td><td style="width:50%;"><strong>太字</strong></td></tr>
+<tr><th><%= image_tag("jstoolbar/italic.svg", { alt: "斜体" }) %></th><td>*斜体*</td><td><em>斜体</em></td></tr>
+<tr><th><%= image_tag("jstoolbar/strikethrough.svg", { alt: "取り消し線" }) %></th><td>~~取り消し線~~</td><td><del>取り消し線</del></td></tr>
+<tr><th><%= image_tag("jstoolbar/letter-c.svg", { alt: "整形済みテキスト" }) %></th><td>`コード`</td><td><code>コード</code></td></tr>
+<tr><th><span class="syntax-pre"/></th><td>```<br>&nbsp;複数行の<br>&nbsp;コード<br>```</td><td>
+<pre>
+ 複数行の
+ コード
+</pre>
+</td></tr>
+
+<tr><th colspan="3">コードハイライト <span class="more_info">(<a href="<%= help_wiki_syntax_path(:detailed, anchor: "13") %>" target="_blank">詳細</a> | <a href="<%= help_code_highlighting_path %>" target="_blank">対応言語</a>)</span></th></tr>
+<tr><th><%= image_tag("jstoolbar/code.svg", { alt: "コードハイライト" }) %></th><td>``` ruby<br>3.times do<br>&nbsp;&nbsp;puts 'Hello'<br>end<br>```</td><td>
+<pre><code class="ruby syntaxhl"><span class="mi">3</span><span class="p">.</span><span class="nf">times</span> <span class="k">do</span>
+  <span class="nb">puts</span> <span class="s1">'Hello'</span>
+<span class="k">end</span>
+</code></pre>
+</td></tr>
+
+<tr><th colspan="3">改行と段落</th></tr>
+<tr><th></th><td>空行は<br><br>新しい段落を<br>作ります</td><td><p>空行は</p><p>新しい段落を作ります</p></td></tr>
+<tr><th></th><td>バックスラッシュで終わる行\<br>または半角スペース2個で改行を挿入します</td><td><p>バックスラッシュで終わる行<br>または空白2個で改行を挿入します</p></td></tr>
+
+<tr><th colspan="3">リスト</th></tr>
+<tr><th><%= image_tag("jstoolbar/list.svg", { alt: "順不同リスト" }) %></th><td>* 項目1<br>&nbsp;&nbsp;* 下位階層の項目<br>* 項目2</td><td><ul><li>項目1<ul><li>下位階層の項目</li></ul></li><li>項目2</li></ul></td></tr>
+<tr><th><%= image_tag("jstoolbar/list-numbers.svg", { alt: "番号付きリスト" }) %></th><td>1. 項目1<br>&nbsp;&nbsp;&nbsp;1. 下位階層の項目<br>2. 項目2</td><td><ol><li>項目1<ol><li>下位階層の項目</li></ol></li><li>項目2</li></ol></td></tr>
+<tr><th><%= image_tag("jstoolbar/list-check.svg", { alt: "タスクリスト" }) %></th><td>* [ ] 項目1<br>* [x] 項目2</td><td><ul style="list-style-type: none; padding-left: 12px;"><li><input type="checkbox" disabled>項目1</li><li><input type="checkbox" disabled checked>項目2</li></ul></td></tr>
+
+<tr><th colspan="3">見出し <span class="more_info">(<a href="<%= help_wiki_syntax_path(:detailed, anchor: "8") %>" target="_blank">詳細</a>)</span></th></tr>
+<tr><th><%= image_tag("jstoolbar/h1.svg", { alt: "見出し1" }) %></th><td># タイトル1</td><td><h1>タイトル1</h1></td></tr>
+<tr><th><%= image_tag("jstoolbar/h2.svg", { alt: "見出し2" }) %></th><td>## タイトル2</td><td><h2>タイトル2</h2></td></tr>
+<tr><th><%= image_tag("jstoolbar/h3.svg", { alt: "見出し3" }) %></th><td>### タイトル3</td><td><h3>タイトル3</h3></td></tr>
+
+<tr><th colspan="3">リンク <span class="more_info">(<a href="<%= help_wiki_syntax_path(:detailed, anchor: "4") %>" target="_blank">詳細</a>)</span></th></tr>
+<tr><th></th><td>www.foo.bar</td><td><a href="#">www.foo.bar</a></td></tr>
+<tr><th></th><td>http://foo.bar</td><td><a href="#">http://foo.bar</a></td></tr>
+<tr><th></th><td>[Foo](http://foo.bar)</td><td><a href="#">Foo</a></td></tr>
+
+<tr><th colspan="3">Redmine内のリンク <span class="more_info">(<a href="<%= help_wiki_syntax_path(:detailed, anchor: "3") %>" target="_blank">詳細</a>)</span></th></tr>
+<tr><th><%= image_tag("jstoolbar/wiki_link.svg", { alt: "Wikiページへのリンク" }) %></th><td>[[Wiki page]]</td><td><a href="#">Wiki page</a></td></tr>
+<tr><th></th><td>チケット #12</td><td>チケット <a href="#">#12</a></td></tr>
+<tr><th></th><td>##12</td><td><a href="#">Bug #12</a>: The issue subject</td></tr>
+<tr><th></th><td>リビジョン r43</td><td>リビジョン <a href="#">r43</a></td></tr>
+<tr><th></th><td>commit:f30e13e43</td><td><a href="#">f30e13e4</a></td></tr>
+<tr><th></th><td>source:some/file</td><td><a href="#">source:some/file</a></td></tr>
+
+<tr><th colspan="3">画像 <span class="more_info">(<a href="<%= help_wiki_syntax_path(:detailed, anchor: "7") %>" target="_blank">詳細</a>)</span></th></tr>
+<tr><th><%= image_tag("jstoolbar/image.svg", { alt: "画像" }) %></th><td>![](<em>画像URL</em>)</td><td></td></tr>
+<tr><th></th><td>![](<em>添付ファイル名</em>)</td><td></td></tr>
+
+<tr><th colspan="3">表</th></tr>
+<tr>
+  <th></th>
+  <td>| A | B | C |<br>|---|---|---|<br>| A | B | C |<br>| D | E | F |</td>
+  <td>
+    <table class="sample">
+      <tbody>
+        <th>A</th><th>B</th><th>C</th>
+        <tr><td>A</td><td>B</td><td>C</td></tr>
+        <tr><td>D</td><td>E</td><td>F</td></tr>
+      </tbody>
+    </table>
+  </td>
+</tr>
+
+<tr><th colspan="3">HTMLを直接使用する<span class="more_info">(<a href="<%= help_wiki_syntax_path(:detailed, anchor: "15") %>" target="_blank">詳細</a>)</span></th></tr>
+<tr>
+  <th></th><td>HTML is &lt;del&gt;not&lt;/del&gt; &lt;u&gt;allowed&lt;/u&gt;.</td><td>HTML is <del>not</del> <u>allowed</u>.</td>
+</tr>
+
+<tr><th colspan="3">アラートボックス <span class="more_info">(<a href="<%= help_wiki_syntax_path(:detailed, anchor: "16") %>" target="_blank">詳細</a>)</span></th></tr>
+<tr><th></th><td>&gt; [!NOTE]<br>&gt; 次のようなアラートボックスが使えます [!NOTE], [!TIP], [!IMPORTANT], [!WARNING], [!CAUTION].</td><td>
+<div class="markdown-alert markdown-alert-note">
+<p class="markdown-alert-title">Note</p>
+<p>次のようなアラートボックスが使えます [!NOTE], [!TIP], [!IMPORTANT], [!WARNING], [!CAUTION].</p>
+</div>
+</td></tr>
+
+</table>
+
+<p><a href="<%= help_wiki_syntax_path(:detailed) %>" onclick="window.open('<%= help_wiki_syntax_path(:detailed) %>', '', ''); return false;">より詳細なリファレンス</a></p>
+</body>
+</html>
diff --git a/app/views/help/wiki_syntax/common_mark/ja/wiki_syntax_detailed_common_mark.html.erb b/app/views/help/wiki_syntax/common_mark/ja/wiki_syntax_detailed_common_mark.html.erb
new file mode 100644
index 0000000000..b2a23a0d5e
--- /dev/null
+++ b/app/views/help/wiki_syntax/common_mark/ja/wiki_syntax_detailed_common_mark.html.erb
@@ -0,0 +1,428 @@
+<!DOCTYPE html>
+<html>
+<head>
+<title>RedmineWikiFormatting (CommonMark Markdown (GitHub Flavored))</title>
+<meta charset="UTF-8">
+<%= stylesheet_link_tag "wiki_syntax_detailed.css" %>
+</head>
+
+<body>
+<h1><a name="1" class="wiki-page"></a>Wiki記法 (CommonMark Markdown (GitHub Flavored))</h1>
+
+    <ul class='toc'>
+        <li><a href='#2'>Links</a></li>
+        <ul>
+            <li><a href='#3'>Redmine内のリンク</a></li>
+            <li><a href='#4'>外部リンク</a></li>
+        </ul>
+        <li><a href='#5'>テキストの書式</a></li>
+        <ul>
+            <li><a href='#6'>文字の書式</a></li>
+            <li><a href='#7'>画像</a></li>
+            <li><a href='#8'>見出し</a></li>
+            <li><a href='#10'>引用</a></li>
+            <li><a href='#11'>目次</a></li>
+            <li><a href='#14'>区切り線</a></li>
+        </ul>
+        <li><a href='#12'>マクロ</a></li>
+        <li><a href='#13'>コードハイライト</a></li>
+        <li><a href='#15'>HTMLを直接使用する</a></li>
+        <li><a href='#16'>アラートボックス</a></li>
+    </ul>
+
+    <h2><a name="2" class="wiki-page"></a>Links</h2>
+
+        <h3><a name="3" class="wiki-page"></a>Redmine内のリンク</h3>
+
+        <p>RedmineはWiki記法が使える箇所のどこからでも、チケット・チェンジセット・Wikiページなどのリソースへのリンクができます。</p>
+        <ul>
+            <li>チケットへのリンク: <strong>#124</strong> (終了したチケットは <del><a href="#" class="issue" title="bulk edit doesn't change the category or fixed version properties (Closed)">#124</a></del> のように取り消し線付きで表示されます)</li>
+            <li>チケットへのリンク (トラッカー名と題名も表示): <strong>##124</strong> (表示例: <a href="#" class="issue" title="bulk edit doesn't change the category or fixed version properties (New)">Bug #124</a>: bulk edit doesn't change the category or fixed version properties)</li>
+            <li>チケットのコメントへのリンク: <strong>#124-6</strong> または <strong>#124#note-6</strong></li>
+            <li>同じチケット内のコメントへのリンク: <strong>#note-6</strong></li>
+        </ul>
+
+        <p>Wikiへのリンク:</p>
+
+        <ul>
+            <li><strong>[[Guide]]</strong> "Guide"という名称のページへのリンク: <a href="#" class="wiki-page">Guide</a></li>
+            <li><strong>[[Guide#further-reading]]</strong> "Guide"というページ内の"further-reading"というアンカーに飛びます。見出しには自動的にアンカーが設定されるのでこのようにリンク先とすることができます: <a href="#" class="wiki-page">Guide</a></li>
+            <li><strong>[[#further-reading]]</strong> 同じページ内のアンカー"further-reading"へのリンク: <a href="#" class="wiki-page">#further-reading</a></li>
+            <li><strong>[[Guide|User manual]]</strong> "Guide"というページへのリンクを異なるテキストで表示: <a href="#" class="wiki-page">User manual</a></li>
+        </ul>
+
+        <p>別のプロジェクトのwikiへのリンクも可能です:</p>
+
+        <ul>
+            <li><strong>[[sandbox:some page]]</strong> sandboxというプロジェクトのwikiの"some page"という名称のページへのリンク</li>
+            <li><strong>[[sandbox:]]</strong> sanbdoxというプロジェクトのwikiのメインページへのリンク</li>
+        </ul>
+
+        <p>存在しないwikiページへのリンクは赤で表示されます。 例: <a href="#" class="wiki-page new">Nonexistent page</a>.</p>
+
+        <p>そのほかのリソースへのリンク:</p>
+
+        <ul>
+            <li>文書:
+                <ul>
+                    <li><strong>document#17</strong> (id 17の文書へのリンク)</li>
+                    <li><strong>document:Greetings</strong> ("Greetings" というタイトルの文書へのリンク)</li>
+                    <li><strong>document:"Some document"</strong> (文書のタイトルに空白が含まれる場合はダブルクォーテーションで囲んでください)</li>
+                    <li><strong>sandbox:document:"Some document"</strong> ("sandbox" というプロジェクトの "Some document" というタイトルの文書へのリンク)</li>
+                </ul>
+            </li>
+        </ul>
+
+        <ul>
+            <li>バージョン:
+                <ul>
+                    <li><strong>version#3</strong> (id 3のバージョンへのリンク)</li>
+                    <li><strong>version:1.0.0</strong> ("1.0.0"という名称のバージョンへのリンク)</li>
+                    <li><strong>version:"1.0 beta 2"</strong></li>
+                    <li><strong>sandbox:version:1.0.0</strong> ("sandbox"というプロジェクトの "1.0.0" という名称のバージョンへのリンク)</li>
+                </ul>
+            </li>
+        </ul>
+
+        <ul>
+            <li>添付ファイル:
+                <ul>
+                    <li><strong>attachment:file.zip</strong> (現在のオブジェクトに添付された file.zip というファイルへのリンク)</li>
+                    <li>現在のオブジェクト上の添付ファイルのみリンク先として指定できます (例えばあるチケットからは、そのチケットに添付されたファイルのみリンク先にできます)</li>
+                </ul>
+            </li>
+        </ul>
+
+        <ul>
+            <li>チェンジセット:
+                <ul>
+                    <li><strong>r758</strong>                       (チェンジセットへのリンク)</li>
+                    <li><strong>commit:c6f4d0fd</strong>            (ハッシュ値によるチェンジセットへのリンク)</li>
+                    <li><strong>svn1|r758</strong>                  (複数のリポジトリが設定されたプロジェクトで、特定のリポジトリのチェンジセットへのリンク)</li>
+                    <li><strong>commit:hg|c6f4d0fd</strong>         (ハッシュ値による、特定のリポジトリのチェンジセットへのリンク)</li>
+                    <li><strong>sandbox:r758</strong>               (他のプロジェクトのチェンジセットへのリンク)</li>
+                    <li><strong>sandbox:commit:c6f4d0fd</strong>    (ハッシュ値による、他のプロジェクトのチェンジセットへのリンク)</li>
+                </ul>
+            </li>
+        </ul>
+
+        <ul>
+             <li>リポジトリ内のファイル:
+                <ul>
+                    <li><strong>source:some/file</strong>           (プロジェクトのリポジトリ内の /some/file というファイルへのリンク)</li>
+                    <li><strong>source:some/file@52</strong>        (ファイルのリビジョン52へのリンク)</li>
+                    <li><strong>source:some/file#L120</strong>      (ファイルの120行目へのリンク)</li>
+                    <li><strong>source:some/file@52#L120</strong>   (リビジョン52のファイルの120行目へのリンク)</li>
+                    <li><strong>source:"some file@52#L120"</strong> (URLにスペースが含まれる場合はダブルクォーテーションで囲んでください)</li>
+                    <li><strong>export:some/file</strong>           (ファイルのダウンロードを強制)</li>
+                    <li><strong>source:svn1|some/file</strong>      (複数のリポジトリが設定されたプロジェクトで、特定のリポジトリのファイルへのリンク)</li>
+                    <li><strong>sandbox:source:some/file</strong>   ("sandbox" というプロジェクトのリポジトリ上の /some/file というファイルへのリンク)</li>
+                    <li><strong>sandbox:export:some/file</strong>   (ファイルのダウンロードを強制)</li>
+                </ul>
+            </li>
+        </ul>
+
+        <ul>
+            <li>フォーラム:
+                <ul>
+                    <li><strong>forum#1</strong> (id 1のフォーラムへのリンク)</li>
+                    <li><strong>forum:Support</strong> ("Support"という名称のフォーラムへのリンク)</li>
+                    <li><strong>forum:"Technical Support"</strong> (フォーラム名に空白が含まれる場合はダブルクォーテーションで囲んでください)</li>
+                </ul>
+            </li>
+        </ul>
+
+        <ul>
+            <li>フォーラムのメッセージ:
+                <ul>
+                    <li><strong>message#1218</strong> (id 1218のメッセージへのリンク)</li>
+                </ul>
+            </li>
+        </ul>
+
+        <ul>
+            <li>プロジェクト:
+                <ul>
+                    <li><strong>project#3</strong> (id 3のプロジェクトへのリンク)</li>
+                    <li><strong>project:someproject</strong> ("someproject"という名称のプロジェクトへのリンク)</li>
+                    <li><strong>project:"some project"</strong> (プロジェクト名に空白が含まれる場合はダブルクォーテーションで囲んでください)</li>
+                </ul>
+             </li>
+        </ul>
+
+        <ul>
+            <li>ニュース:
+                <ul>
+                    <li><strong>news#2</strong> (id 2のニュースへのリンク)</li>
+                    <li><strong>news:Greetings</strong> ("Greetings"というタイトルのニュースへのリンク)</li>
+                    <li><strong>news:"First Release"</strong> (タイトルに空白が含まれる場合はダブルクォーテーションで囲んでください)</li>
+                </ul>
+            </li>
+        </ul>
+
+        <ul>
+            <li>ユーザー:
+                <ul>
+                    <li><strong>user#2</strong> (id 2のユーザーへのリンク)</li>
+                    <li><strong>user:jsmith</strong> (jsmith というログインIDのユーザーへのリンク)</li>
+                    <li><strong>@jsmith</strong> (jsmith というログインIDのユーザーへのリンク)</li>
+                </ul>
+            </li>
+        </ul>
+
+        <p>エスケープ:</p>
+
+        <ul>
+            <li>テキストをRedmineのリンクとして解釈させたくない場合は感嘆符 ! を前につけてください。</li>
+        </ul>
+
+
+        <h3><a name="4" class="wiki-page"></a>外部リンク</h3>
+
+        <p>URL(starting with: www, http, https, ftp, ftps, sftp and sftps)とメールアドレスは自動的にリンクになります:</p>
+
+<pre>
+http://www.redmine.org, someone@foo.bar
+</pre>
+
+        <p>上記記述の表示例です: <a class="external" href="http://www.redmine.org">http://www.redmine.org</a>, <a href="mailto:someone@foo.bar" class="email">someone@foo.bar</a></p>
+
+        <p>URLのかわりに別のテキストを表示させたい場合は、通常のMarkdown記法が利用できます:</p>
+
+<pre>
+[Redmine web site](http://www.redmine.org)
+</pre>
+
+        <p>上記記述の表示例です: <a href="http://www.redmine.org" class="external">Redmine web site</a></p>
+
+
+    <h2><a name="5" class="wiki-page"></a>テキストの書式</h2>
+
+    <p>見出し、太字、テーブル、リスト等は、RedmineはMarkdownでの記述に対応しています。Markdownの詳細は <a class="external" href="https://commonmark.org/">CommonMark</a> を参照してください。なお文法のなかには、いくつか<em>GitHub flavored Markdown</em>と呼ばれる拡張が追加されています。拡張については <a class="external" href="https://github.github.com/gfm">GitHub Flavored Markdown Spec</a> を参照してください。以下にいくつかのサンプルを提示しますが、実際にはここで取り上げた以外の記法にも対応しています。</p>
+
+        <h3><a name="6" class="wiki-page"></a>文字の書式</h3>
+
+<pre>
+* **太字**
+* *斜体*
+* ***太字で斜体***
+* ~~取り消し線~~
+</pre>
+
+        <p>表示例:</p>
+
+        <ul>
+            <li><strong>太字</strong></li>
+            <li><em>斜体</em></li>
+            <li><em><strong>太字で斜体</strong></em></li>
+            <li><del>取り消し線</del></li>
+        </ul>
+
+        <h3><a name="7" class="wiki-page"></a>画像</h3>
+
+        <ul>
+            <li><strong>![](image_url)</strong> image_urlで指定されたURLの画像を表示 (Markdownの記法)</li>
+            <li>Wikiページに添付された画像があれば、ファイル名を指定して画像を表示させることができます: <strong>![](attached_image)</strong></li>
+            <li>PCのクリップボード内の画像は Ctrl-v または Command-v で直接貼り付けることができます。</li>
+            <li>画像ファイルをテキストエリアにドロップするとアップロードと画像の埋め込みが行われます。</li>
+        </ul>
+
+        <h3><a name="8" class="wiki-page"></a>見出し</h3>
+
+<pre>
+# Heading
+## Subheading
+### Subsubheading
+</pre>
+
+        <p>Redmineは見出しにアンカーを設定するので、"#Heading", "#Subheading"のように記述して見出しへのリンクが行えます。</p>
+
+
+        <h3><a name="10" class="wiki-page"></a>引用</h3>
+
+        <p>段落を <strong>&gt;</strong> で開始してください。</p>
+
+<pre>
+&gt; Rails is a full-stack framework for developing database-backed web applications according to the Model-View-Control pattern.
+To go live, all you need to add is a database and a web server.
+</pre>
+
+        <p>表示例:</p>
+
+        <blockquote>
+                <p>Rails is a full-stack framework for developing database-backed web applications according to the Model-View-Control pattern.<br>To go live, all you need to add is a database and a web server.</p>
+        </blockquote>
+
+
+        <h3><a name="11" class="wiki-page"></a>目次</h3>
+
+<pre>
+{{toc}} =&gt; 目次(左寄せ)
+{{&gt;toc}} =&gt; 目次(右寄せ)
+</pre>
+
+        <h3><a name="14" class="wiki-page"></a>区切り線</h3>
+
+<pre>
+---
+</pre>
+
+    <h2><a name="12" class="wiki-page"></a>マクロ</h2>
+
+    <p>Redmineには以下の組み込みマクロが用意されています:</p>
+
+    <p>
+    <dl>
+      <dt><code>hello_world</code></dt>
+      <dd><p>サンプルのマクロです。</p></dd>
+
+      <dt><code>macro_list</code></dt>
+      <dd><p>利用可能なマクロの一覧を表示します。マクロの説明があればそれも表示します。</p></dd>
+
+      <dt><code>child_pages</code></dt>
+      <dd><p>子ページの一覧を表示します。引数の指定が無ければ現在のwikiページの子ページを表示します。以下は使用例です:</p>
+      <pre><code>{{child_pages}} -- wikiページでのみ使用可能です
+{{child_pages(depth=2)}} -- 2階層分のみ表示します</code></pre></dd>
+
+      <dt><code>include</code></dt>
+      <dd><p>別のWikiページの内容を挿入します。 以下は使用例です:</p>
+      <pre><code>{{include(Foo)}}</code></pre>
+      <p>別プロジェクトのWikiページを挿入することもできます:</p>
+      <pre><code>{{include(projectname:Foo)}}</code></pre></dd>
+
+      <dt><code>collapse</code></dt>
+      <dd><p>折り畳まれた状態のテキストを挿入します。以下は使用例です:</p>
+      <pre><code>{{collapse(詳細を表示...)
+この部分はデフォルトでは折り畳まれた状態で表示されます。
+リンクをクリックすると展開されます。
+}}</code></pre></dd>
+
+      <dt><code>thumbnail</code></dt>
+      <dd><p>添付ファイルのクリック可能なサムネイル画像を表示します。以下は使用例です:</p>
+      <pre>{{thumbnail(image.png)}}
+{{thumbnail(image.png, size=300, title=Thumbnail)}}</pre></dd>
+
+      <dt><code>issue</code></dt>
+      <dd><p>チケットへのリンクをカスタマイズ可能なテキストとともに挿入します。以下は使用例です:</p>
+      <pre>{{issue(123)}}                              -- Issue #123: Enhance macro capabilities
+{{issue(123, project=true)}}                -- Andromeda - Issue #123:Enhance macro capabilities
+{{issue(123, tracker=false)}}               -- #123: Enhance macro capabilities
+{{issue(123, subject=false, project=true)}} -- Andromeda - Issue #123</pre></dd>
+
+      <dt><code>recent_pages</code></dt>
+      <dd><p>最近更新された Wikiページを表示します。オプションがない場合は直近7日間に更新されたページを表示します。以下は使用例です:</p>
+        <pre>{{recent_pages}}            -- 直近7日間に更新されたページを表示します
+{{recent_pages(days=3)}}    -- 直近3日間に更新されたページを表示します
+{{recent_pages(limit=5)}}   -- 表示するページの数を5件までに制限します
+{{recent_pages(time=true)}} -- 直近7日間に更新されたページを更新時間とともに表示します</pre></dd>
+    </dl>
+    </p>
+
+    <h2><a name="13" class="wiki-page"></a>コードハイライト</h2>
+
+    <p>RedmineはRubyで記述されたコードハイライト用ライブラリ <a href="http://rouge.jneen.net/" class="external">Rouge</a> を使用しています。Rougeは <strong>c</strong>, <strong>cpp</strong> (c++), <strong>csharp</strong> (c#, cs), <strong>css</strong>, <strong>diff</strong> (patch, udiff), <strong>go</strong> (golang), <strong>groovy</strong>, <strong>html</strong>, <strong>java</strong>, <strong>javascript</strong> (js), <strong>kotlin</strong>, <strong>objective_c</strong> (objc), <strong>perl</strong> (pl), <strong>php</strong>, <strong>python</strong> (py), <strong>r</strong>, <strong>ruby</strong> (rb), <strong>sass</strong>, <strong>scala</strong>, <strong>shell</strong> (bash, zsh, ksh, sh), <strong>sql</strong>, <strong>swift</strong>, <strong>xml</strong>, <strong>yaml</strong> (yml) など一般的に使われている多数の言語に対応しています（括弧内の名前はコードハイライトの指定に利用できる別名です）。全対応言語の一覧は <a href="<%= help_code_highlighting_path %>" target="_blank">Redmineのコードハイライトでサポートされている言語の一覧</a> を参照してください。</p>
+
+    <p>Wiki記法に対応している箇所であればどこでも以下の記述によりコードハイライトが利用できます (言語名・別名では大文字・小文字は区別されません):</p>
+
+<pre>
+```ruby
+  Place your code here.
+```
+</pre>
+
+    <p>表示例:</p>
+
+<pre><code class="ruby syntaxhl"><span class="c1"># The Greeter class</span>
+<span class="k">class</span> <span class="nc">Greeter</span>
+  <span class="k">def</span> <span class="nf">initialize</span><span class="p">(</span><span class="nb">name</span><span class="p">)</span>
+    <span class="vi">@name</span> <span class="o">=</span> <span class="nb">name</span><span class="p">.</span><span class="nf">capitalize</span>
+  <span class="k">end</span>
+
+  <span class="k">def</span> <span class="nf">salute</span>
+    <span class="nb">puts</span> <span class="s2">"Hello </span><span class="si">#{</span><span class="vi">@name</span><span class="si">}</span><span class="s2">!"</span>
+  <span class="k">end</span>
+<span class="k">end</span>
+</code></pre>
+
+    <h2><a name="15" class="wiki-page"></a>HTMLを直接使用する</h2>
+
+    <p>複数の行や列がが結合している表のような複雑なフォーマットを記述したいときはMarkdown記法を使わずHTMLを直接書くこともできます。</p>
+
+  <pre><code>
+    &lt;table width="50%"&gt;
+      &lt;tr&gt;&lt;td rowspan="2"&gt;Two rows&lt;/td&gt;&lt;td&gt;foo&lt;/td&gt;&lt;/tr&gt;
+      &lt;tr&gt;&lt;td&gt;bar&lt;/td&gt;&lt;/tr&gt;
+      &lt;tr&gt;&lt;td align="center" colspan="2"&gt;bar&lt;/td&gt;&lt;/tr&gt;
+    &lt;/table&gt;
+  </code></pre>
+
+  <p>以下のようになります</p>
+
+<table width="50%" class="sample">
+<tr><td rowspan="2">Two rows</td><td>foo</td></tr>
+<tr><td>bar</td></tr>
+<tr><td align="center" colspan="2">bar</td></tr>
+</table>
+
+<p>HTMLを直接書く場合は固有なスタイル設定のために<strong>style</strong>属性を使用できます。以下のCSSプロパティが使用できます。</p>
+<pre><code>
+  color background-color
+  width min-width max-width
+  height min-height max-height
+  padding padding-left padding-right padding-top padding-bottom
+  margin margin-left margin-right margin-top margin-bottom
+  border border-left border-right border-top border-bottom border-radius border-style border-collapse border-spacing
+  font font-style font-variant font-weight font-stretch font-size line-height font-family
+  text-align
+  float
+</code></pre>
+
+    <h2><a name="16" class="wiki-page"></a>アラートボックス</h2>
+
+    <p>
+    <dl>
+      <dt><code>注釈</code></dt>
+      <dd>
+        <pre><code>&gt; [!NOTE]<br>&gt; Wikiページを編集すると履歴が保存されます。必要な場合は以前のバージョンに戻すこともできます。</code></pre>
+        <div class="markdown-alert markdown-alert-note">
+        <p class="markdown-alert-title">Note</p>
+        <p>Wikiページを編集すると履歴が保存されます。必要な場合は以前のバージョンに戻すこともできます。</p>
+        </div>
+      </dd>
+      <dt><code>助言</code></dt>
+      <dd>
+      <pre><code>&gt; [!TIP]<br>&gt; チケットの更新履歴をざっくり振り返るには、「履歴」タブを見るのが便利です。</code></pre>
+      <div class="markdown-alert markdown-alert-tip">
+          <p class="markdown-alert-title">Tip</p>
+          <p>チケットの更新履歴をざっくり振り返るには、「履歴」タブを見るのが便利です。</p>
+      </div>
+      </dd>
+      <dt><code>注意</code></dt>
+      <dd>
+      <pre><code>&gt; [!WARNING]<br>&gt; チケットは削除してしまうと復旧できません。削除する前に本当に必要かどうかを必ず確認してください。</code></pre>
+      <div class="markdown-alert markdown-alert-warning">
+          <p class="markdown-alert-title">Warning</p>
+          <p>チケットは削除してしまうと復旧できません。削除する前に本当に必要かどうかを必ず確認してください。</p>
+      </div>
+      </dd>
+      <dt><code>重要</code></dt>
+      <dd>
+      <pre><code>&gt; [!IMPORTANT]<br>&gt; ロールの権限を変更すると全てのプロジェクトに影響します。潜在的な影響に注意してください。</code></pre>
+      <div class="markdown-alert markdown-alert-important">
+          <p class="markdown-alert-title">Important</p>
+          <p>ロールの権限を変更すると全てのプロジェクトに影響します。潜在的な影響に注意してください。</p>
+      </div>
+      </dd>
+      <dt><code>警告</code></dt>
+      <dd>
+      <pre><code>&gt; [!CAUTION]<br>&gt; プラグインをインストールするときは互換性を検証するように注意してください。バージョンの相違によって予想できない挙動をする可能性があります。</code></pre>
+      <div class="markdown-alert markdown-alert-caution">
+          <p class="markdown-alert-title">Caution</p>
+          <p>プラグインをインストールするときは互換性を検証するように注意してください。バージョンの相違によって予想できない挙動をする可能性があります。</p>
+      </div>
+      </dd>
+    </dl>
+    </p>
+
+</body>
+</html>
-- 
2.39.5